/*
: VisualRelink.js
 : JavaScript.
:      Adobe InDesign.
:         .
 : Sergei-Anosov@yandex.ru
*/
//
// *****  
//
if(app.documents.length == 0) {exit()};
AD = app.activeDocument;	// . -
D_NAME = AD.name;	//  . -
var NS = app.activeDocument.spreads.length // -   -
var NMS = app.activeDocument.masterSpreads.length // -   -
AS = app.activeWindow.activeSpread;	//   . 		
BEGIN_WINDOW = app.activeWindow;	//   ( )
F_NAME = new Array() ;	//   
SHOW_NAME = new Array(); 	//       
F_PATH = new Array(); 	//   
F_IND = new Array()	;	//   
DOC_LINKS = app.activeDocument.links	//     -
var N_LINK=DOC_LINKS.length //  -   -
var N_REL = 0;		// -  
var N_FILES = 0 ;		//  - 
var AUTO = 0;		//  
var DIAP = 0;		//  
var F_NAME_i ="";		//   
var F_PATH_i ="";		//   
var SPR_i	;		//  
var OLD_FILE_PATH = ""	//   
var NEW_FILE_PATH = ""	//   
var OLD_FILE_NAME =""	//   
var NEW_FILE_NAME = ""	//   
var FS_N = 0;		//   
var RELINK_YES = true;	//   .
var N_FAILED = 0;		//  
var N_EMBEDDED = 0;	//  
var N_EMB_FILES = 0;	// .   -
var  WHAT_SHOW;		//     
var PROC_EMBEDDED=false	//   
var CAN_SHOW = false;	//   
var TITLE = "VisualRelink    ";
//
//  
//
FILE_INFO();
SORT_NAMES();
SORT_SHOW_NAMES();
do {
	if(!DIALOG_SHOW()) exit();
	READ_NEW_FILE();
} while (!RELINK_YES);	
RELINK_IN_DOC();
DISPLAY_RESULT();
DESELECT_ALL();
RESTORE_VIEW();
exit();
//
// *****     
//
function READ_NEW_FILE() {
RELINK_YES = true;
var SD = "     "+F_NAME[FS_N];
	do {
	NEW_FILE_PATH = File.openDialog(SD);
	if(NEW_FILE_PATH == null) {
		if (confirm("   ! ?") == true) {
			RELINK_YES = false;
			break;
		}
		continue;
	}
	//
	//    
	//
	NEW_FILE_PATH  = unescape(NEW_FILE_PATH.fsName);
	//
	//    
	//
	NEW_FILE_NAME = GET_FILE_NAME(NEW_FILE_PATH);
	//
	//        (  )
	//
	var s1 = unescape(NEW_FILE_PATH);
	var l = s1.length;
	var F_EXT = s1.substring( l-3, l);
	F_EXT = F_EXT.toLowerCase();
	if(F_EXT != "tif" && F_EXT != "psd" && F_EXT != "eps" && F_EXT != "jpg" 
			  && F_EXT != "pdf" && F_EXT != "bmp" && F_EXT != ".ai" 
			  && F_EXT != "gif" && F_EXT != "dcs" && F_EXT != "wmf"
			  && F_EXT != "emf" && F_EXT != "pcx" && F_EXT != "png"
			  && F_EXT != "sct" && F_EXT != "ict" ) {
		alert("    !");
		continue;
	}
	var CONF_STR =  
		         TITLE +"\n"+
		         ": "+D_NAME+"\n\n"+
		         "  : "+OLD_FILE_NAME+"\n"+
		         OLD_FILE_PATH+"\n\n"+
	     	         "  : "+ NEW_FILE_NAME+"\n"+
		          NEW_FILE_PATH+"\n\n"+
			 " ?";
	if (confirm(CONF_STR) == false) {
		RELINK_YES = false; 
		return;
	}
	return;
	} while (true);
return;
}

//
// *****   .  
//
function FILE_INFO() {
//   .  
//    F_NAME  F_PATH .  
//   -   N_FILES
//
	for (var i = 0; i < N_LINK; i++) {//      -
		if(DOC_LINKS.item(i).status == LinkStatus.linkEmbedded) { 
			N_EMB_FILES++;
		}
		if(i == 0) {//   (0) 
			F_NAME[0] = unescape(DOC_LINKS.item(0).name);
			if( version_CS() ) F_PATH[0] = unescape(DOC_LINKS.item(0).filePath.fsName)
			else F_PATH[0] = unescape(DOC_LINKS.item(0).filePath)
			N_FILES = 1
			continue;
		}
		FILE_IN_ARRAY = false;
		F_NAME_i = unescape(DOC_LINKS.item(i).name);
		if( version_CS() ) F_PATH_i = unescape(DOC_LINKS.item(i).filePath.fsName)
		else F_PATH_i = unescape(DOC_LINKS.item(i).filePath)
		for (var j=0; j<N_FILES; j++){//    
			if ((F_NAME_i == F_NAME[j]) && (F_PATH_i == F_PATH[j])){
 				FILE_IN_ARRAY = true;//      
				break;
			}
		}
		if(FILE_IN_ARRAY == true) { continue }
		F_NAME.push(F_NAME_i)
		F_PATH.push(F_PATH_i)
		N_FILES++;
	}
	if ( N_LINK == 0) {
		alert("    !");
		exit();
	}
return
}
//
// *****     
//
function SORT_NAMES() {
	for (var i=0; i < N_FILES; i++) {
		for(var j=0; j < N_FILES-1; j++) {
			var F_NAME_j = F_NAME[j];
			var F_PATH_j = F_PATH[j];
			if (FIRST_STR(F_NAME[j],F_NAME[j+1]) == 0) { //   
				//
				//    
				//
				if (FIRST_STR(F_PATH[j],F_PATH[j+1]) == 1) {
					continue;
				}
				if (FIRST_STR(F_PATH[j],F_PATH[j+1]) == 2) {
					F_NAME[j] = F_NAME[j+1];
					F_NAME[j+1] = F_NAME_j;
					F_PATH[j] = F_PATH[j+1];
					F_PATH[j+1] = F_PATH_j;
					continue;
				}
			}
			if (FIRST_STR(F_NAME[j],F_NAME[j+1]) == 1) {
				continue;
			}
			if (FIRST_STR(F_NAME[j],F_NAME[j+1]) == 2) {
				F_NAME[j] = F_NAME[j+1];
				F_NAME[j+1] = F_NAME_j;
				F_PATH[j] = F_PATH[j+1];
				F_PATH[j+1] = F_PATH_j;
				continue;
			}
		}
	}
return
}
//
// *****         
//
function SORT_SHOW_NAMES() {
	for( var i=0; i < N_FILES; i++) {
		var F_NAME_i = unescape(F_NAME[i])
		var F_PATH_i = F_PATH[i]
		SHOW_NAME[i] = F_NAME_i + " >> " + F_PATH_i;
	}
return;
}
//
// ******    
//
//    ,     
//    ,     
//       , 
//    
//
//  :
// 0,   
// 1,   s1
// 2,   s2
//
function FIRST_STR(s1,s2) {
	var sl1 = s1.length
	var sl2 = s2.length
	var N = Math.min(sl1, sl2);
	if (s1 == s2) {
		return 0;
	}
	for(var i = 0; i < N; i++) {
		var c1 = s1.charCodeAt(i);
		var c2 = s2.charCodeAt(i);
		if(c1 < c2) {
			return 1;
		}
		if(c1 > c2) {
			return 2;
		}
	}
	if (sl1 < sl2) { 
		return 1;
	}
	if (sl1 > sl2) { 
		return 2;
	}
}// FIRST_STR
//
// *****    
//
function DIALOG_SHOW() {
var myDialog = app.dialogs.add({name:TITLE});
with(myDialog) {
	with(dialogColumns.add()){
		var S_EMB = "";
		if (N_EMB_FILES > 0) S_EMB = "    : "+N_EMB_FILES;	
		dialogRows.add().staticTexts.add({staticLabel:": "+D_NAME});
		dialogRows.add().staticTexts.add({staticLabel:": "+N_LINK+"   : "+N_FILES+S_EMB});
		if( N_EMB_FILES > 0 ) {
		PROC_EMBEDDED = dialogRows.add().checkboxControls.add({staticLabel:"  ", checkedState:true});
		}
		dialogRows.add().staticTexts.add({staticLabel:"    : "});
                		var SELECTED_FILE = dropdowns.add({stringList:SHOW_NAME, selectedIndex:0, minWidth:300});
		with(dialogRows.add()){
            		with(dialogColumns.add()){
		dialogRows.add().staticTexts.add({staticLabel:" :"});
		with( AUTO = radiobuttonGroups.add()){
			radiobuttonControls.add({staticLabel:"", checkedState:true});
			radiobuttonControls.add({staticLabel:"."});
		}
		}
		with(dialogColumns.add()){
		dialogRows.add().staticTexts.add({staticLabel:" :"});
		with( DIAP = radiobuttonGroups.add()){
			radiobuttonControls.add({staticLabel:". "});
			radiobuttonControls.add({staticLabel:" -", checkedState:true});
		}
		}
		with(dialogColumns.add()){
		dialogRows.add().staticTexts.add({staticLabel:":"});
		with( WHAT_SHOW = radiobuttonGroups.add()){
			radiobuttonControls.add({staticLabel:"", checkedState:true});
			radiobuttonControls.add({staticLabel:" ."});
		
		
		}
		}
	}
	}

}
if(myDialog.show()) {
	FS_N = SELECTED_FILE.selectedIndex;
	OLD_FILE_PATH = F_PATH[FS_N];
	OLD_FILE_NAME = F_NAME[FS_N];
	AUTO = AUTO.selectedButton;
	DIAP = DIAP.selectedButton;
	WHAT_SHOW = WHAT_SHOW.selectedButton;
	if( N_EMB_FILES > 0 ) PROC_EMBEDDED = PROC_EMBEDDED.checkedState;
	myDialog.destroy();
return true
};
exit();
}
//
// *****      
//
function GET_FILE_NAME(s1) {
	var s2 = ""
	var l = s1.length;
	for(var i=l-1; i>0; i--) {
		if( s1[i] != "\\" && s1[i] != "/" ){
			var s2 = s1[i] + s2;
			continue;
		}
		break;
	}
return s2;
}
//
// *****   
//
function FIX_PATH(s1) {
	var len = s1.length
	s2 = ""
	for( i=0; i < len; i++){
		var c = s1.charAt(i);
		if( c  == "\\") {
			s2 = s2 + c
		}
		s2 = s2 + c
	}
return s2;
}
//
// ********   
//
function DESELECT_ALL() {
app.select( null );
return
} 
//
// ********    
//
function zoomObject(theObj) {
 if(WHAT_SHOW == 0) theObj = theObj.parent;
 var objBounds = theObj.geometricBounds;
 var ObjHeight = objBounds[2] - objBounds[0];
 var ObjWidth = objBounds[3] - objBounds[1];
 var myWindow = app.activeWindow;
 var pageBounds = myWindow.activePage.bounds;
 var PgeHeight = pageBounds[2] - pageBounds[0];
 var PgeWidth = pageBounds[3] - pageBounds[1];
 var hRatio = PgeHeight/ObjHeight;
 var wRatio = PgeWidth/ObjWidth;
 var zoomRatio = Math.min(hRatio, wRatio);
try {
	app.select(theObj, SelectionOptions.replaceWith);
	myWindow.zoom(ZoomOptions.fitPage);
	myWindow.zoomPercentage = myWindow.zoomPercentage * zoomRatio;
	CAN_SHOW = true;
}
catch ( error ) {
	CAN_SHOW = false;
}
return
}
//
// ********     
//
function RELINK_IN_SPREAD (the_spread, old_path, new_path) {
//
// -    
//
var N_G = the_spread.allGraphics.length;
SPR_i = the_spread
for(var i=0; i < N_G; i++){
	Graph_i = the_spread.allGraphics[i];
	var Link_i = Graph_i.itemLink;
	if(  version_CS() ) var F_Path_i = Link_i.filePath.fsName
	else var F_Path_i = Link_i.filePath
	if(old_path == F_Path_i){
		if( Link_i.status == LinkStatus.linkEmbedded && !PROC_EMBEDDED ) {
			N_EMBEDDED++;
			continue;
		}
		if(AUTO == 0){ 
			dial_found(Graph_i);
			if( ASSIGN ){
				Link_i.relink(new_path);
				Link_i.update();
				N_REL++;}
			else continue;}
		else { 
			Link_i.relink(new_path);
			Link_i.update();
			N_REL++;
		}			
	}
}
return;
}
//
// ********      
//
function dial_found(obj_found) {
DESELECT_ALL();

with(myDialog2 = app.dialogs.add({name:TITLE, canCancel:false})){
	var P_NAMES = "";
	//
	//    
	//
	if(SPR_i.constructor.name == "Spread") {
		SPR_i_name = SPR_i.index+1;
	}
	//
	//   
	//
	if(SPR_i.constructor.name == "MasterSpread") {
		SPR_i_name = SPR_i.name;
	}
	//
	//    
	//
	for(var i=0; i < SPR_i.pages.length; i++){
		if(SPR_i.pages.length == 1) {
			P_NAMES = P_NAMES+SPR_i.pages[i].name;
			break;
		}
		if( i == 0){
			P_NAMES = SPR_i.pages[i].name;
			continue;
		}
		P_NAMES = P_NAMES+"-"+SPR_i.pages[i].name;
	}
	with(dialogColumns.add()){
		zoomObject(obj_found);
		dialogRows.add().staticTexts.add({staticLabel:": "+D_NAME});
		dialogRows.add().staticTexts.add({staticLabel:": "+SPR_i_name + "  : "+P_NAMES});
		dialogRows.add().staticTexts.add({staticLabel:"  :  "+OLD_FILE_NAME});
		dialogRows.add().staticTexts.add({staticLabel:"   :  "+NEW_FILE_NAME});
		dialogRows.add().staticTexts.add({staticLabel:" "});
		if( !CAN_SHOW ){ 
			dialogRows.add().staticTexts.add({staticLabel:"  !"});
		       	dialogRows.add().staticTexts.add({staticLabel:" "});
		}
		with( WHAT2 = radiobuttonGroups.add()){
			radiobuttonControls.add({staticLabel:" ", checkedState:true});
			radiobuttonControls.add({staticLabel:""});
			radiobuttonControls.add({staticLabel:" "});
		}
	}
	
	myDialog2.show();
}// with
WHAT2 = WHAT2.selectedButton;
myDialog2.destroy();
if(WHAT2 == 0) {
	ASSIGN = true;
	return
}
if(WHAT2 == 1) {
	N_FAILED++;
	ASSIGN = false;
	return;
}
if(WHAT2 == 2) {
	DISPLAY_RESULT();
	DESELECT_ALL();
	RESTORE_VIEW();
	exit();
}
return;
}
//
// ********      
//
function RELINK_IN_DOC() {
//
//   
//
if(DIAP == 0){
	RELINK_IN_SPREAD(AS, OLD_FILE_PATH, NEW_FILE_PATH);
return;
}
//
//   
//
if(DIAP == 1){
	//
	//  
	//
	for(var i = 0; i < NS; i++){
		RELINK_IN_SPREAD(app.activeDocument.spreads[i], OLD_FILE_PATH, NEW_FILE_PATH);
	}
	//
	// 
	//
	for(var i = 0; i < NMS; i++){
		RELINK_IN_SPREAD(app.activeDocument.masterSpreads[i], OLD_FILE_PATH, NEW_FILE_PATH);
	}
return;
}
}// function
//
// ********     
//
function DISPLAY_RESULT(){
var S_FAILED ="";
var S_EMBEDDED ="";
if ( N_FAILED > 0 ) S_FAILED = ": "+N_FAILED+"\n";
if ( N_EMBEDDED > 0 ) S_EMBEDDED = " : "+N_EMBEDDED+"\n";
alert(
TITLE + "\n"+
": "+D_NAME+ "\n\n"+
"  :  "+OLD_FILE_NAME+"\n"+
OLD_FILE_PATH+"\n\n"+
"  :  "+NEW_FILE_NAME+"\n"+
NEW_FILE_PATH+"\n\n"+
" : "+N_REL+"\n"+
S_FAILED+
S_EMBEDDED);
return;
}
//
// ********    InDesign
//
function version_CS() {
var VERSION = app.version +"";
if(VERSION.substr(0,1) == "3") { return true;}
return false;
}
//
//      
//
function RESTORE_VIEW() {
app.activeWindow.activeSpread = AS;
BEGIN_WINDOW.zoom(ZoomOptions.fitSpread);
return;
}